Properties Methods Events Direct Link

# Class Date

Package: | Global
Defined In: | Date.js
Class: | Date
Extends: | Object

The date parsing and format syntax is a subset of PHP's date() function, and the formats that are supported will provide results equivalent to their PHP versions. The following is a list of all currently supported formats:

    Format  Description                                                               Example returned values
    ------  -----------------------------------------------------------------------   -----------------------
      d     Day of the month, 2 digits with leading zeros                             01 to 31
      D     A short textual representation of the day of the week                     Mon to Sun
      j     Day of the month without leading zeros                                    1 to 31
      l     A full textual representation of the day of the week                      Sunday to Saturday
      N     ISO-8601 numeric representation of the day of the week                    1 (for Monday) through 7 (for Sunday)
      S     English ordinal suffix for the day of the month, 2 characters             st, nd, rd or th. Works well with j
      w     Numeric representation of the day of the week                             0 (for Sunday) to 6 (for Saturday)
      z     The day of the year (starting from 0)                                     0 to 364 (365 in leap years)
      W     ISO-8601 week number of year, weeks starting on Monday                    01 to 53
      F     A full textual representation of a month, such as January or March        January to December
      m     Numeric representation of a month, with leading zeros                     01 to 12
      M     A short textual representation of a month                                 Jan to Dec
      n     Numeric representation of a month, without leading zeros                  1 to 12
      t     Number of days in the given month                                         28 to 31
      L     Whether it's a leap year                                                  1 if it is a leap year, 0 otherwise.
      o     ISO-8601 year number (identical to (Y), but if the ISO week number (W)    Examples: 1998 or 2004
            belongs to the previous or next year, that year is used instead)
      Y     A full numeric representation of a year, 4 digits                         Examples: 1999 or 2003
      y     A two digit representation of a year                                      Examples: 99 or 03
      a     Lowercase Ante meridiem and Post meridiem                                 am or pm
      A     Uppercase Ante meridiem and Post meridiem                                 AM or PM
      g     12-hour format of an hour without leading zeros                           1 to 12
      G     24-hour format of an hour without leading zeros                           0 to 23
      h     12-hour format of an hour with leading zeros                              01 to 12
      H     24-hour format of an hour with leading zeros                              00 to 23
      i     Minutes, with leading zeros                                               00 to 59
      s     Seconds, with leading zeros                                               00 to 59
      u     Milliseconds, with leading zeros                                          001 to 999
      O     Difference to Greenwich time (GMT) in hours and minutes                   Example: +1030
      P     Difference to Greenwich time (GMT) with colon between hours and minutes   Example: -08:00
      T     Timezone abbreviation of the machine running the code                     Examples: EST, MDT, PDT ...
      Z     Timezone offset in seconds (negative if west of UTC, positive if east)    -43200 to 50400
      c     ISO 8601 date                                                             2007-04-17T15:19:21+08:00
      U     Seconds since the Unix Epoch (January 1 1970 00:00:00 GMT)                1193432466 or -2138434463

Example usage (note that you must escape format specifiers with '\\' to render them as character literals):

    // Sample date:
    // 'Wed Jan 10 2007 15:05:01 GMT-0600 (Central Standard Time)'

    var dt = new Date('1/10/2007 03:05:01 PM GMT-0600');
    document.write(dt.format('Y-m-d'));                         // 2007-01-10
    document.write(dt.format('F j, Y, g:i a'));                 // January 10, 2007, 3:05 pm
    document.write(dt.format('l, \\t\\he jS of F Y h:i:s A'));  // Wednesday, the 10th of January 2007 03:05:01 PM

Here are some standard date/time patterns that you might find helpful. They are not part of the source of Date.js, but to use them you can simply copy this block of code into any script that is included after Date.js and they will also become globally available on the Date object. Feel free to add or remove patterns as needed in your code.

    Date.patterns = {
        ISO8601Long:"Y-m-d H:i:s",
        ISO8601Short:"Y-m-d",
        ShortDate: "n/j/Y",
        LongDate: "l, F d, Y",
        FullDateTime: "l, F d, Y g:i:s A",
        MonthDay: "F d",
        ShortTime: "g:i A",
        LongTime: "g:i:s A",
        SortableDateTime: "Y-m-d\\TH:i:s",
        UniversalSortableDateTime: "Y-m-d H:i:sO",
        YearMonth: "F, Y"
    };

Example usage:

    var dt = new Date();
    document.write(dt.format(Date.patterns.ShortDate));

## Public Properties

Property | Defined By
--- | ---
| Date.DAY : String <static> Date interval constant | Date
| Date.HOUR : String <static> Date interval constant | Date
| Date.MILLI : String <static> Date interval constant | Date
| Date.MINUTE : String <static> Date interval constant | Date
| Date.MONTH : String <static> Date interval constant | Date
| Date.SECOND : String <static> Date interval constant | Date
| Date.YEAR : String <static> Date interval constant | Date
| Date.dayNames : Array <static> An array of textual day names. Override these values for international dates, for example... Date.dayN... <static> An array of textual day names. Override these values for international dates, for example... Date.dayNames = ['SundayInYourLang', 'MondayInYourLang', ...]; | Date
| Date.monthNames : Array <static> An array of textual month names. Override these values for international dates, for example... Date.mo... <static> An array of textual month names. Override these values for international dates, for example... Date.monthNames = ['JanInYourLang', 'FebInYourLang', ...]; | Date

Date.monthNumbers : Object
<static> An object hash of zero-based javascript month numbers (with short month names as keys. note: keys are ...
<static> An object hash of zero-based javascript month numbers (with short month names as keys. note: keys are case-sensitive). Override these values for international dates, for example... Date.monthNumbers = {'ShortJanNameInYourLang':0, 'ShortFebNameInYourLang':1, ...};

Date

## Public Methods

Method | Defined By
--- | ---

Date.getMonthNumber( `String name` ) : Number
<static> Get the zero-based javascript month number for the given short/full month name. Override this function...
<static> Get the zero-based javascript month number for the given short/full month name. Override this function for international dates.
Parameters:

- `name` : String
  The short/full month name.

Returns:

- `Number`
  The zero-based javascript month number.

Date

Date.getShortDayName( `Number day` ) : String
<static> Get the short day name for the given day number. Override this function for international dates.
<static> Get the short day name for the given day number. Override this function for international dates.
Parameters:

- `day` : Number
  A zero-based javascript day number.

Returns:

- `String`
  The short day name.

Date

Date.getShortMonthName( `Number month` ) : String
<static> Get the short month name for the given month number. Override this function for international dates.
<static> Get the short month name for the given month number. Override this function for international dates.
Parameters:

- `month` : Number
  A zero-based javascript month number.

Returns:

- `String`
  The short month name.

Date

Date.parseDate( `String input`, `String format` ) : Date
<static> Parses the passed string using the specified format. Note that this function expects dates in normal c...
<static> Parses the passed string using the specified format. Note that this function expects dates in normal calendar format, meaning that months are 1-based (1 = January) and not zero-based like in JavaScript dates. Any part of the date format that is not specified will default to the current date value for that part. Time parts can also be specified, but default to 0. Keep in mind that the input date string must precisely match the specified format string or the parse operation will fail. Example Usage:

    //dt = Fri May 25 2007 (current date)
    var dt = new Date();

    //dt = Thu May 25 2006 (today's month/day in 2006)
    dt = Date.parseDate("2006", "Y");

    //dt = Sun Jan 15 2006 (all date parts specified)
    dt = Date.parseDate("2006-01-15", "Y-m-d");

    //dt = Sun Jan 15 2006 15:20:01 GMT-0600 (CST)
    dt = Date.parseDate("2006-01-15 3:20:01 PM", "Y-m-d h:i:s A" );

Parameters:

- `input` : String
  The unparsed date as a string.
- `format` : String
  The format the date is in.

Returns:

- `Date`
  The parsed date.

Date

add( `String interval`, `Number value` ) : Date
Provides a convenient method of performing basic date arithmetic. This method does not modify the Date instance bein...
Provides a convenient method of performing basic date arithmetic. This method does not modify the Date instance being called - it creates and returns a new Date instance containing the resulting date value. Examples:

    //Basic usage:
    var dt = new Date('10/29/2006').add(Date.DAY, 5);
    document.write(dt); //returns 'Fri Oct 06 2006 00:00:00'

    //Negative values will subtract correctly:
    var dt2 = new Date('10/1/2006').add(Date.DAY, -5);
    document.write(dt2); //returns 'Tue Sep 26 2006 00:00:00'

    //You can even chain several calls together in one line!
    var dt3 = new Date('10/1/2006').add(Date.DAY, 5).add(Date.HOUR, 8).add(Date.MINUTE, -30);
    document.write(dt3); //returns 'Fri Oct 06 2006 07:30:00'

Parameters:

- `interval` : String
  A valid date interval enum value.
- `value` : Number
  The amount to add to the current date.

Returns:

- `Date`
  The new Date instance.

Date

between( `Date start`, `Date end` ) : Boolean
Checks if this date falls on or between the given start and end dates.
Checks if this date falls on or between the given start and end dates.
Parameters:

- `start` : Date
  Start date
- `end` : Date
  End date

Returns:

- `Boolean`
  true if this date falls on or between the given start and end dates.

Date

clearTime( `Boolean clone` ) : Date
Clears any time information from this date.
Clears any time information from this date.
Parameters:

- `clone` : Boolean
  true to create a clone of this date, clear the time and return it (defaults to false).

Returns:

- `Date`
  this or the clone.

Date

clone() : Date
Creates and returns a new Date instance with the exact same date value as the called instance. Dates are copied and p...
Creates and returns a new Date instance with the exact same date value as the called instance. Dates are copied and passed by reference, so if a copied date variable is modified later, the original variable will also be changed. When the intention is to create a new variable that will not modify the original instance, you should create a clone. Example of correctly cloning a date:

    //wrong way:
    var orig = new Date('10/1/2006');
    var copy = orig;
    copy.setDate(5);
    document.write(orig);  //returns 'Thu Oct 05 2006'!

    //correct way:
    var orig = new Date('10/1/2006');
    var copy = orig.clone();
    copy.setDate(5);
    document.write(orig);  //returns 'Thu Oct 01 2006'

Parameters:

- None.

Returns:

- `Date`
  The new Date instance.

Date

format( `String format` ) : String
Formats a date given the supplied format string.
Formats a date given the supplied format string.
Parameters:

- `format` : String
  The format string.

Returns:

- `String`
  The formatted date.

Date

getDayOfYear() : Number
Get the numeric day number of the year, adjusted for leap year.
Get the numeric day number of the year, adjusted for leap year.
Parameters:

- None.

Returns:

- `Number`
  0 to 364 (365 in leap years).

Date

getDaysInMonth() : Number
Get the number of days in the current month, adjusted for leap year.
Get the number of days in the current month, adjusted for leap year.
Parameters:

- None.

Returns:

- `Number`
  The number of days in the month.

Date

getElapsed( [`Date date`] ) : Number
Returns the number of milliseconds between this date and date
Returns the number of milliseconds between this date and date
Parameters:

- `date` : Date
  (optional) Defaults to now

Returns:

- `Number`
  The diff in milliseconds

Date

getFirstDateOfMonth() : Date
Get the date of the first day of the month in which this date resides.
Get the date of the first day of the month in which this date resides.
Parameters:

- None.

Returns:

- `Date`

Date

getFirstDayOfMonth() : Number
Get the first day of the current month, adjusted for leap year. The returned value is the numeric day index within t...
Get the first day of the current month, adjusted for leap year. The returned value is the numeric day index within the week (0-6) which can be used in conjunction with the monthNames array to retrieve the textual day name. Example:

    var dt = new Date('1/10/2007');
    document.write(Date.dayNames[dt.getFirstDayOfMonth()]); //output: 'Monday'

Parameters:

- None.

Returns:

- `Number`
  The day number (0-6).

Date

getGMTOffset( `Boolean colon` ) : String
Get the offset from GMT of the current date (equivalent to the format specifier 'O').
Get the offset from GMT of the current date (equivalent to the format specifier 'O').
Parameters:

- `colon` : Boolean
  true to separate the hours and minutes with a colon (defaults to false).

Returns:

- `String`
  The 4-character offset string prefixed with + or - (e.g. '-0600').

Date

getLastDateOfMonth() : Date
Get the date of the last day of the month in which this date resides.
Get the date of the last day of the month in which this date resides.
Parameters:

- None.

Returns:

- `Date`

Date

getLastDayOfMonth() : Number
Get the last day of the current month, adjusted for leap year. The returned value is the numeric day index within th...
Get the last day of the current month, adjusted for leap year. The returned value is the numeric day index within the week (0-6) which can be used in conjunction with the monthNames array to retrieve the textual day name. Example:

    var dt = new Date('1/10/2007');
    document.write(Date.dayNames[dt.getLastDayOfMonth()]); //output: 'Wednesday'

Parameters:

- None.

Returns:

- `Number`
  The day number (0-6).

Date

getSuffix() : String
Get the English ordinal suffix of the current day (equivalent to the format specifier 'S').
Get the English ordinal suffix of the current day (equivalent to the format specifier 'S').
Parameters:

- None.

Returns:

- `String`
  'st, 'nd', 'rd' or 'th'.

Date

getTimezone() : String
Get the timezone abbreviation of the current date (equivalent to the format specifier 'T'). Note: The date string ret...
Get the timezone abbreviation of the current date (equivalent to the format specifier 'T'). Note: The date string returned by the javascript Date object's toString() method varies between browsers (e.g. FF vs IE) and system region settings (e.g. IE in Asia vs IE in America). For a given date string e.g. "Thu Oct 25 2007 22:55:35 GMT+0800 (Malay Peninsula Standard Time)", getTimezone() first tries to get the timezone abbreviation from between a pair of parentheses (which may or may not be present), failing which it proceeds to get the timezone abbreviation from the GMT offset portion of the date string.
Parameters:

- None.

Returns:

- `String`
  The abbreviated timezone name (e.g. 'CST', 'PDT', 'EDT', 'MPST' ...).

Date

getWeekOfYear() : Number
Get the numeric ISO-8601 week number of the year. (equivalent to the format specifier 'W', but without a leading zero).
Get the numeric ISO-8601 week number of the year. (equivalent to the format specifier 'W', but without a leading zero).
Parameters:

- None.

Returns:

- `Number`
  1 to 53

Date

isLeapYear() : Boolean
Whether or not the current date is in a leap year.
Whether or not the current date is in a leap year.
Parameters:

- None.

Returns:

- `Boolean`
  True if the current date is in a leap year, else false.

Date

## Public Events

This class has no public events.